package com.company.nested_embeddable.entity;

import io.jmix.core.entity.annotation.EmbeddedParameters;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;

@JmixEntity
@Embeddable
public class FirstLevelEmbeddable {
    @Column(name = "FIRST_LEVEL_ATTRIBUTE")
    private String firstLevelAttribute;

    @EmbeddedParameters(nullAllowed = false)
    @Embedded
    @AttributeOverrides({
            @AttributeOverride(name = "secondLevelAttribute", column = @Column(name = "FIRST_LEVEL_EMBEDDED_ATTRIBUTE_SECOND_LEVEL_ATTRIBUTE"))
    })
    private SecondLevelEmbeddable firstLevelEmbeddedAttribute;

    public SecondLevelEmbeddable getFirstLevelEmbeddedAttribute() {
        return firstLevelEmbeddedAttribute;
    }

    public void setFirstLevelEmbeddedAttribute(SecondLevelEmbeddable firstLevelEmbeddedAttribute) {
        this.firstLevelEmbeddedAttribute = firstLevelEmbeddedAttribute;
    }

    public String getFirstLevelAttribute() {
        return firstLevelAttribute;
    }

    public void setFirstLevelAttribute(String firstLevelAttribute) {
        this.firstLevelAttribute = firstLevelAttribute;
    }
}